#!hs2
#!load hwindows.hsm
#!load hstrings.hsm

########Variablen####################################

varset( $antwort, 0 ) # Rckgabe der Msg-Boxen
varset( $midfile, HamPath + "deletemid.kill" ) # Datei mit M-Ids
varset( $ok, 0 ) #Rckgabe ob Abbruch bei interaktiv; Erkennung ob interaktiv
var( $midlist, $msg_id, $grpname, $artno, $arttext, $subject )
var( $i, $grphdl, $mid ) #Hilfsvariablen
####################################################

## Zu Anfang mu entschieden werden, ob die M-IDs aus einer Datei gelesen
## werden, oder ob diese eingegeben werden

$antwort = MsgBox( "Aus der Datei auslesen?", "Liste oder interaktiv", 0x3) 
                     # 7 nein; 6 ja; 2 cancel

icase( $antwort, 2, abbruch,_
		 6, delete_ausdatei,_
                 7, delete_interaktiv )
quit

sub delete_ausdatei
  if( Fileexists( $midfile ))
    $midlist = ListAlloc 
    Listload( $midlist, $midfile ) 
    for ($i, 0, Listcount( $midlist ) - 1, 1 ) # == Anzahl M-IDs
      $msg_id = ListGet( $midlist, $i ) # i-tes Element auslesen
      $antwort = search_mid( $msg_id )      
      icase( $antwort, 2, abbruch,_
		       6, delete_yes,_
		       7, delete_no,_
		       8, wrong_mid )
    endfor
  endif

  $antwort = MsgBox( "Liste aufrumen?", _
		     "Markierte Eintrge (alte und neue)", 0x4) 
                     # 7 nein; 6 ja;
  if( $antwort = 6 )
    Listsave( $midlist, $midfile + ".bak")    
    clear_file
  endif
Listsave( $midlist, $midfile )
Listfree( $midlist )
endsub
quit	

sub delete_interaktiv
  while( true )
    $msg_id = InputBox( "Bitte Message-ID eingeben", "", "", $ok )
    if( !$ok  )
      quit
    endif      
    $antwort = search_mid( $msg_id )
    icase( $antwort, 2, abbruch,_
		     6, delete_yes,_
		     7, delete_no,_
		     8, wrong_mid )
  endwhile
endsub

sub search_mid ( $mid )
  if( HamArtLocateMId( $mid, $grpname, $artno ) = 0 ) #gibt es die M-ID?
    $grphdl = HamGroupopen( $grpname )               
    $arttext = HamArtText( $grphdl, $artno )
    HamGroupclose( $grphdl )
    $subject = Re_Extract( $arttext, "Subject:.*" )
    $antwort = MsgBox( "Soll " + $CRLF + $subject_
		       + "in Gruppe: " + $grpname_
		       + " gelscht werden?",_		       
		       "Letzte Chance", 0x3)
    return ( $antwort )
  endif
return( 8 )
endsub

sub delete_yes
  HamArtDeleteMid( $msg_id )
  if( !$ok ) #Liste wird ausgelesen
    Listset( $midlist, $i, $msg_id + " gelscht" ) #zusatz gelscht hinter M-ID
  endif    
  print( "Posting " + $msg_id + " in Gruppe "_
	 + $grpname + " gelscht" )
  return
endsub

sub delete_no
  print( "Posting " + $msg_id + " in Gruppe "_
	 + $grpname + " nicht gelscht" )
  return
endsub  

sub wrong_mid
  print( $msg_id + " ist eine falsche MID oder schon gelscht" )
  return
endsub

sub Abbruch
  if( !$ok ) #Liste
    $antwort = MsgBox( "Liste aufrumen?", _
		       "Markierte Eintrge (alte und neue)", 0x4) 
                       # 7 nein; 6 ja;
    if( $antwort = 6 )
      Listsave( $midlist, $midfile + ".bak")    
      clear_file
    endif
    Listsave( $midlist, $midfile )
    Listfree( $midlist)
  endif  
  quit
endsub

sub clear_file
 for( $i, 0, Listcount( $midlist ) - 1, 1 )
    if( Re_Match( ListGet( $midlist, $i ), "gelscht" ))
      ListDelete( $midlist, $i )
      dec( $i )
    endif
  endfor
endsub